<?php
// PRIVATECONTENT INTEGRATIONS - ADMIN SIDE


//// box in "add user" page 
// new user - box to set user subscription
// old user - box to associate plan
// pcpp user - summarize pcpp data and allow edit

function pcpp_add_user_block($fdata, $user_id) {
	if(!$GLOBALS['pcpp_enabled']) {return false;}
	include_once(PCPP_DIR .'/functions.php');
	global $pc_users, $pcpp_subscr;
		
	/*** NEW USER ***/
	if(empty($user_id)) { 
		?>
        <h3 style="border: none !important;">Premium Plans add-on</h3>
		<table class="widefat pc_table pc_add_user" style="margin-bottom: 25px;">
		  <tbody>
			<tr>
                <td class="pc_label_td"><?php _e("Select user subscription's plan", 'pcpp_ml') ?> <span class="pc_req_field">*</span></td>
                <td class="pc_field_td">
                	<select name="pcpp_plan" class="lcweb-chosen" data-placeholder="<?php _e('Select a plan', 'pcpp_ml') ?> .." autocomplete="off" style="width: 100%; max-width: 350px;">
                   	
                    	<option value="no_plan"><?php _e("No plan associated", 'pcpp_ml') ?></option>
  
					<?php
                   	foreach($pcpp_subscr->get_plans(false) as $plan_id => $plan_name) {
						$to_match = (isset($_POST['pcpp_plan']) && $_POST['pcpp_plan']) ? $_POST['pcpp_plan'] : get_option('pcpp_default_plan', 0);
						$sel = ($plan_id == $to_match) ? 'selected="selected"' : '';
						echo '<option value="'. $plan_id .'" '.$sel.'>'. $plan_name . pcpp_dd_plan_details($plan_id) .'</option>';	
					}
					?>
                   </select>
                </td>
			</tr>
            <?php if($pcpp_subscr->is_trial_enabled()) : ?>
            <tr>
            	<td class="pc_label_td">
					<?php _e('Apply trial period?', 'pcpp_ml') ?> (<?php echo $pcpp_subscr->trial_duration.' '.pcpp_sing_plur_switch($pcpp_subscr->trial_dur_type, $pcpp_subscr->trial_duration); ?>)
                </td>
                <td class="pc_field_td">
                	<?php $ckd = (isset($_POST['pcpp_apply_trial']) && $_POST['pcpp_apply_trial']) ? 'checked="checked"' : ''; ?>
                   <input type="checkbox" name="pcpp_apply_trial" value="1" <?php echo $ckd ?> autocomplete="off" class="ip_checks">
                </td>
            </tr>
            <?php endif; ?>
		  </tbody>
		</table>
	<?php
	}
	
	
	/*** EXISTING USER ***/
	else {
		// prior user subscription check
		$pcpp_subscr->check_user_subscr_expir($user_id);
		
		// get pcpp data
		$fields = array('pcpp_plan', 'pcpp_subscr_end', 'pcpp_subscr_status', 'pcpp_trial_ending', 'pcpp_active_order', 'pcpp_orders');
		$ud = $pc_users->get_user($user_id, array('to_get' => $fields));

		// user hasn't got plan 
		if(empty($ud['pcpp_plan'])) {
			echo '
			<h3 style="border: none !important;">Premium Plans add-on</h3>
			<div class="pc_warn pc_warning">
				<p>'. __("User doesn't have any plan associated", 'pcpp_ml') .' - <a href="javascript:void(0)" id="pcpp_no_plan_associate" style="cursor: pointer;">'. __('assign plan', 'pcpp_ml') .'</a></p>
				
				<div id="pcpp_no_plan_associate_wrap" style="display: none;">
					'. __('Select plan', 'pcpp_ml') .'
					<div style="display: inline-block; padding: 0 20px;">
						<select name="pcpp_plan" class="lcweb-chosen" data-placeholder="'. __('Select plan', 'pcpp_ml') .'.." autocomplete="off" style="width: 350px;">';

					foreach($pcpp_subscr->get_plans(false) as $plan_id => $plan_name) {
						echo '<option value="'. $plan_id .'">'. $plan_name . pcpp_dd_plan_details($plan_id) .'</option>';	
					}
				
				echo '		
						</select>
					</div>
					<input type="button" value="'. __('Assign', 'pcpp_ml') .'" class="button-secondary" />
					<span style=" padding-left: 20px;"></span>';
					
				// whether to ask to enable trial period
				if($pcpp_subscr->is_trial_enabled()) {
					echo '
					<div style=" margin-top: 12px;"> '.
						__('Apply trial period?', 'pcpp_ml') .' ('.$pcpp_subscr->trial_duration.' '.pcpp_sing_plur_switch($pcpp_subscr->trial_dur_type, $pcpp_subscr->trial_duration) .')
						<i style="display: inline-block; width: 15px;"></i>
						<input type="checkbox" name="pcpp_apply_trial" id="pcpp_apply_trial" value="1" autocomplete="off" class="ip_checks">
					</div>';
				}
					
				echo '	
				</div>
			</div>';
			?>
			<script type="text/javascript">
			jQuery(document).ready(function(e) {
				var pcpp_is_acting = false;
				
				// assign plan
				jQuery('#pcpp_no_plan_associate_wrap input').click(function() {
					if(pcpp_is_acting) {return false;}
					
					pcpp_is_acting = true;
					jQuery('#pcpp_no_plan_associate_wrap > span').html('<div class="pc_loading" style="margin-bottom: -7px;"></div>');
					
					// trial period bool
					if(jQuery('#pcpp_apply_trial').size()) {
						var use_trial = (jQuery('#pcpp_apply_trial').is(':checked')) ? 1 : 0;
					}
					else {var use_trial = 0;}
						
					var data = {
						action: 'pcpp_no_plan_associate',
						user_id: <?php echo $user_id ?>,
						plan_id: jQuery('#pcpp_no_plan_associate_wrap select').val(),
						use_trial: use_trial, 
						pcpp_nonce: '<?php echo wp_create_nonce('lcwp_ajax') ?>'
					};
					jQuery.post(ajaxurl, data, function(response) {	
						if(jQuery.trim(response) == 'success') {
							jQuery('#pcpp_no_plan_associate_wrap > span').html("<?php _e('Plan successfully associated', 'pcpp_ml') ?>!");
							setTimeout(function() {
								window.location.reload();
							}, 1500);	
						}
						else {
							jQuery('#pcpp_no_plan_associate_wrap > span').html(response);
							pcpp_is_acting = false;	
						}
					});
				});
				
				// show selector
				jQuery('#pcpp_no_plan_associate').click(function() {
					jQuery('#pcpp_no_plan_associate_wrap').slideDown();
					jQuery(this).parent().slideUp();
				});
			});
			</script>
			<?php
		}
		
		// user has plan - management
		else {
			$exp_date_visibility = ($ud['pcpp_subscr_status'] == 'active') ? '' : 'pcpp_hide_exp_date'; 
			$plans_list = $pcpp_subscr->get_plans(false);
			
			// trial expiration date block
			if($ud['pcpp_subscr_status'] == 'trial') {
				$teb = '
				<td id="pcpp_trial_exp_wrap">
					<h4>'. __('Trial expiration date', 'pcpp_ml') .'</h4>
					<span>'. pcpp_time_to_date_html($ud['pcpp_trial_ending']) .'</span>
				</td>';
				$tr_class = 'pcpp_eud_is_trial';
			} 
			else {
				$teb = '<td style="display: none;"></td>';
				$tr_class = '';
			}
			
			echo  '
			<h3 style="border: none !important;">Premium Plans add-on - '. __('subscription details', 'pcpp_ml') .'</h3>
			<table class="widefat pc_table pcpp_add_user_table" style="margin-bottom: 25px;">
				<tr id="pcpp_aut_first_row" class="'. $tr_class .'">
					<td id="pcpp_edit_plan_wrap">
						<h4>'. __('Current plan', 'pcpp_ml') .' <a href="javascript:void(0)" title="'. __('change plan', 'pcpp_ml') .'"></a></h4>
						<p>
							<select name="pcpp_edit_plan" id="pcpp_edit_plan" autocomplete="off" rel="'. $ud['pcpp_plan'] .'">
								<option value="no_plan">'. __("Dissociates from plans", 'pcpp_ml') .'</option>';
								
								foreach($plans_list as $plan_id => $plan_name) {
									$sel = ($ud['pcpp_plan'] == $plan_id) ? 'selected="selected"' : '';
									echo '<option value="'.$plan_id.'" '.$sel.'>'.$plan_name . pcpp_dd_plan_details($plan_id) .'</option>'; 
								}
								
							echo '
							</select>
							<input type="button" class="button-primary" id="pcpp_edit_plan_btn" value="'. __('Apply', 'pcpp_ml') .'" />
							<input type="button" class="button-secondary pcpp_cancel" value="'. __('cancel', 'pcpp_ml') .'" />
						</p>
						<span>'. get_the_title($ud['pcpp_plan']) .'</span>
					</td>
					<td id="pcpp_edit_status_wrap">
						<h4>'. __('Subscription status', 'pcpp_ml') .' <a href="javascript:void(0)" title="'. __('change status', 'pcpp_ml') .'"></a></h4>
						<p>
							<select name="pcpp_edit_status" id="pcpp_edit_status" autocomplete="off">';
								
								foreach(pcpp_subscr_statuses() as $status_id => $status_name) {
									if($status_id == 'trial' || $status_id == 'no_act_order') {continue;}
									if(empty($ud['pcpp_active_order']) && $status_id == 'unpaid') {continue;}
									
									$sel = ($ud['pcpp_subscr_status'] == $status_id) ? 'selected="selected"' : '';
									echo '<option value="'.$status_id.'" '.$sel.'>'.$status_name.'</option>'; 
								}
								
							echo '
							</select>
							<input type="button" class="button-primary" id="pcpp_edit_status_btn" value="'. __('Apply', 'pcpp_ml') .'" />
							<input type="button" class="button-secondary pcpp_cancel" value="'. __('cancel', 'pcpp_ml') .'" />
						</p>
						<span id="pcpp_eus_'. $ud['pcpp_subscr_status'] .'" class="pc_edit_user_status">'. pcpp_subscr_statuses($ud['pcpp_subscr_status']) .'</span>
					</td>
					'.$teb.'
					<td id="pcpp_edit_exp_wrap" class="'.$exp_date_visibility.'">
						<h4>'. __('Expiration date', 'pcpp_ml') .' <a href="javascript:void(0)" title="'. __('change expiration date', 'pcpp_ml') .'"></a></h4>
						<p>
							'. pcpp_edit_exp_date_code($ud['pcpp_subscr_end']) .'
							<input type="button" class="button-primary" id="pcpp_edit_exp_btn" value="'. __('Apply', 'pcpp_ml') .'" />
							<input type="button" class="button-secondary pcpp_cancel" value="'. __('cancel', 'pcpp_ml') .'" style="position: relative; bottom: -2px;" />
							<em id="pcpp_unl_plan_check"><input type="checkbox" '. checked($ud['pcpp_subscr_end'], 'unlimited') .' value="1" autocomplete="off" /> '. __('Unlimited Plan', 'pcpp_ml') .'</em>
						</p>
						<span>'. pcpp_time_to_date_html($ud['pcpp_subscr_end']) .'</span>
					</td>
				</tr>
				<tr>	
					<td colspan="4" id="pcpp_user_orders_list">';
			
					if(empty($ud['pcpp_orders'])) {
						echo "<span>User doesn't have subscription orders yet</span>";	
					}
					else {
						echo '
						<a href="javascript:void(0)" id="pcpp_toggle_orders_history">'. __('show orders history', 'pcpp_ml') .'</a>
						
						<table class="widefat pc_table pc_add_user" id="pcpp_orders_history" style="display:none;">
						  <thead>
						  	<tr>
								<th style="width: 20px;"></th>
								<th style="width: 60px; text-align: center;">'. __('Order ID', 'pcpp_ml') .'</th>
								<th style="width: 130px; text-align: center;">'. __('Submission date', 'pcpp_ml') .'</th>
								<th>'. __('Related Plan', 'pcpp_ml') .'</th>
								<th style="width: 60px;">'. __('Amount', 'pcpp_ml') .'</th>
								<th>'. __('Order Status', 'pcpp_ml') .'</th>
							</tr>
						  </thead>
							';
						
						$a = 0;
						foreach(array_reverse($ud['pcpp_orders']) as $order_id) {
							
							// check if exists - otherwise remove
							if(get_post_status($order_id) === false) {
								$pcpp_subscr->manag_user_orders($user_id, $order_id, 'remove');
								continue;
							}
							
							$date = get_the_date(get_option('date_format'), $order_id);
							$del_block = ($a) ? '<td><span class="pcpp_del_order pc_del_field" title="'. __('delete order', 'pcpp_ml') .'" rel="'.$order_id.'"></span></td>' : '<td></td>';
							
							// WPML & Polylang compatibility - plan name 
							if(!isset($plans_list[ $pcpp_subscr->get_order_plan_id($order_id) ])) { 
								$ol_plan_name = $plans_list[ pcpp_wpml_get_trans_id($pcpp_subscr->get_order_plan_id($order_id)) ];
							} else {
								$ol_plan_name =	$plans_list[ $pcpp_subscr->get_order_plan_id($order_id) ];
							}
							
							echo '
							<tr>
								'.$del_block.'
								<td style="text-align: center;"><a href="'.admin_url( 'post.php?post='.$order_id.'&action=edit').'" target="_blank">#'.$order_id.'</a></td>
								<td style="text-align: center;">'.$date.'</td>
								<td>'. $ol_plan_name .'</td>
								<td>'. pcpp_get_order_amount($order_id) .'</td>
								<td>'.pcpp_get_order_ecomm_status($order_id).'</td>
							</tr>'; 
							
							$a++;
						}
						
						?>
						</table>
					<?php 
					} 
					?>
						
					<script type="text/javascript">
					jQuery(document).ready(function(e) {
						var pcpp_is_acting = false;
						
						// change plan
						jQuery('#pcpp_edit_plan_btn').click(function() {
							var $subj = jQuery(this).parents('td');
							var val = jQuery('#pcpp_edit_plan').val();
							
							if(pcpp_is_acting || val == jQuery('#pcpp_edit_plan').attr('rel')) {return false;}
							
							if(confirm("<?php _e("Do you really want to change subscription's plan? A new order will be created", 'pcpp_ml') ?>")) {
								pcpp_is_acting = true;
								$subj.addClass('pcpp_eud_is_acting');
								
								var data = {
									action: 'pcpp_change_user_plan',
									user_id: <?php echo $user_id ?>,
									plan_id: val,
									pcpp_nonce: '<?php echo wp_create_nonce('lcwp_ajax') ?>'
								};
								jQuery.post(ajaxurl, data, function(response) {
									var resp = jQuery.parseJSON(response);
									
									if(resp.status == 'error') {
										alert(resp.error);	
									}
									else {
										// refresh page to see changes
										window.location.replace("<?php echo admin_url() ?>admin.php?page=pc_add_user&user=<?php echo $user_id ?>");
									}
									
									$subj.removeClass('pcpp_eud_is_acting');
									pcpp_is_acting = false;
								});	
							}
						});
						
						
						// change plan status
						jQuery('#pcpp_edit_status_btn').click(function() {
							var $subj = jQuery(this).parents('td');
							var val = jQuery('#pcpp_edit_status').val();
							
							if(pcpp_is_acting) {return false;}
							
							if(confirm("<?php _e("Do you really want to change subscription's status?", 'pcpp_ml') ?>")) {
								pcpp_is_acting = true;
								$subj.addClass('pcpp_eud_is_acting');
								
								var data = {
									action: 'pcpp_change_user_plan_status',
									user_id: <?php echo $user_id ?>,
									user_plan: jQuery('#pcpp_edit_plan').attr('rel'),
									status: val,
									pcpp_nonce: '<?php echo wp_create_nonce('lcwp_ajax') ?>'
								};
								jQuery.post(ajaxurl, data, function(response) {
									var resp = jQuery.parseJSON(response);
									
									 if(resp.status == 'error') {
										alert(resp.error);	
									}
									else {
										jQuery('span.pc_edit_user_status').attr('id', 'pcpp_eus_' + val);
										jQuery('span.pc_edit_user_status').html( 
											jQuery('#pcpp_edit_status option[value='+val+']').text() 
										);
										$subj.find('input.pcpp_cancel').trigger('click');
	
										// surely different from trial - hide its exp block
										jQuery('#pcpp_aut_first_row').removeClass('pcpp_eud_is_trial');
										
										// if is active - show expiration date
										if(val == 'active') {
											jQuery('#pcpp_edit_exp_wrap').removeClass('pcpp_hide_exp_date');	
										} else {
											jQuery('#pcpp_edit_exp_wrap').addClass('pcpp_hide_exp_date');		
										}
										
										// if active - set update expiration dates
										if(val == 'active') {
											if(resp.is_unl_plan) {
												jQuery('#pcpp_edit_exp_wrap').find('input[type="checkbox"]').attr('checked', 'checked');
												jQuery('#pcpp_edit_exp_wrap').find('select option').removeAttr('selected');
												jQuery('#pcpp_edit_exp_wrap #pcpp_edit_exp_date').val("");
												jQuery('#pcpp_edit_exp_wrap	span').html("<?php _e('Unlimited Plan', 'pcpp_ml') ?>");	
											}
											else {
												jQuery('#pcpp_edit_exp_wrap	span').html(resp.ending_html);	
												jQuery('#pcpp_edit_exp_date').html(resp.ending_date);	
												jQuery('#pcpp_edit_exp_wrap').find('input[type="checkbox"]').removeAttr('checked');	
											}	
										}
									}
									
									$subj.removeClass('pcpp_eud_is_acting');
									pcpp_is_acting = false;
								});	
							}
						});
						
						
						// change plan expiration date
						jQuery('#pcpp_edit_exp_btn').click(function() {
							var $subj = jQuery(this).parents('td');
							if(pcpp_is_acting) {return false;}
							
							if(confirm("<?php _e("Do you really want to change subscription expiration date?", 'pcpp_ml') ?>")) {
								pcpp_is_acting = true;
								$subj.addClass('pcpp_eud_is_acting');
								
								var data = {
									action: 'pcpp_change_user_plan_exp_date',
									user_id: <?php echo $user_id ?>,
									date: jQuery('#pcpp_edit_exp_date').val(),
									time: jQuery('#pcpp_edit_exp_hour').val() +':'+ jQuery('#pcpp_edit_exp_min').val(),
									unlimited: (jQuery('#pcpp_unl_plan_check input').is(':checked')) ? 1 : 0,
									pcpp_nonce: '<?php echo wp_create_nonce('lcwp_ajax') ?>'
								};
								jQuery.post(ajaxurl, data, function(response) {
									var resp = jQuery.parseJSON(response);
									
									if(resp.status == 'error') {
										alert(resp.error);	
									}
									else {
										$subj.find('span').html( resp.ending_html );
										$subj.find('input.pcpp_cancel').trigger('click');
									}
									
									$subj.removeClass('pcpp_eud_is_acting');
									pcpp_is_acting = false;
								});	
							}
						});
						
						
						// delete user order
						jQuery('.pcpp_del_order').click(function() {
							if(pcpp_is_acting) {return false;}
							
							if(confirm("<?php _e("Do you really want to delete this order?", 'pcpp_ml') ?>")) {
								var $subj = jQuery(this);
								pcpp_is_acting = true;
								$subj.addClass('pcpp_duo_loading');
								
								var data = {
									action: 'pcpp_del_user_order',
									user_id: <?php echo $user_id ?>,
									order_id: $subj.attr('rel'),
									pcpp_nonce: '<?php echo wp_create_nonce('lcwp_ajax') ?>'
								};
								jQuery.post(ajaxurl, data, function(response) {
									var resp = jQuery.trim(response);
									
									if(resp != 'success') {
										$subj.removeClass('pcpp_duo_loading');
										pcpp_is_acting = false;
									}
									else {
										window.location.reload();
									}
								});	
							}
						});
						
						/////////////////////////////////////////////////
						
						// show edit block
						jQuery('#pcpp_aut_first_row td h4 a').click(function(){
							var $subj = jQuery(this).parents('td');
							$subj.find('span').hide();
							$subj.find('p').show();
							
							// hide other ones
							jQuery('#pcpp_aut_first_row td').not($subj).find('input.pcpp_cancel').trigger('click');
						});
						
						// hide edit block
						jQuery('#pcpp_aut_first_row td input.pcpp_cancel').click(function(){
							var $subj = jQuery(this).parents('td');
							$subj.find('span').show();
							$subj.find('p').hide();
						});
						
						
						// toggle orders history
						jQuery('#pcpp_toggle_orders_history').click(function(){
							var $subj = jQuery(this);
							
							jQuery('#pcpp_orders_history').slideToggle(function() {
								if( jQuery(this).is(':hidden') ) {
									$subj.html("<?php _e('show orders history', 'pcpp_ml') ?>");
								} else {
									$subj.html("<?php _e('hide orders history', 'pcpp_ml') ?>");	
								}
							});
						});
						
						
						// datepicker for editing expiration date
						var pcpp_datepicker_init = function(type) {
							return {
								dateFormat : (type == 'eu') ? 'dd/mm/yy' : 'yy/mm/dd',
								beforeShow: function(input, inst) {
									jQuery('#ui-datepicker-div').wrap('<div class=\"pcpp_dp\"></div>');
								},
								monthNames: 		pcpp_datepick_str.monthNames,
								monthNamesShort: 	pcpp_datepick_str.monthNamesShort,
								dayNames: 			pcpp_datepick_str.dayNames,
								dayNamesShort: 		pcpp_datepick_str.dayNamesShort,
								dayNamesMin:		pcpp_datepick_str.dayNamesMin,
								isRTL:				pcpp_datepick_str.isRTL
							};	
						}
						
						jQuery('#pcpp_edit_exp_date').datepicker( pcpp_datepicker_init('db') );
					});
					</script>
					<?php
					
			echo '	</td>
				</tr>
			</table>';
		}
	}
}
add_action('pc_add_user_body', 'pcpp_add_user_block', 10, 2);


// "add user" page - require pcpp_plan field only for new users
function pcpp_add_user_require_plan($form_structure) {
	if($GLOBALS['pcpp_enabled'] && !isset($_GET['user'])) {
		if(!isset($form_structure['require'])) {
			$form_structure['require'] = array();	
		}
		
		$form_structure['include'][] = 'pcpp_plan';
		$form_structure['require'][] = 'pcpp_plan';
	}
	
	return $form_structure;
}
add_filter('pc_add_user_form_validation', 'pcpp_add_user_require_plan');



// assign plan on admin user insertion
function pcpp_add_user_assign_plan($user_id) {
	if(!$GLOBALS['pcpp_enabled'] || strpos($_SERVER["REQUEST_URI"], '?page=pc_add_user') === false) {return false;}
	
	include_once(PCPP_DIR .'/functions.php');
	global $pc_meta, $pcpp_subscr;
	$plan_id = $pc_meta->get_meta($user_id, 'pcpp_plan'); 
	
	// no associated plan - remove meta
	if($plan_id == 'no_plan') {
		$pc_meta->delete_meta($user_id, 'pcpp_plan');
		return true;	
	}
	
	
	// plan selected - perform actions
	$order_id = $pcpp_subscr->create_order($user_id, $plan_id);
	
	// set new main order and manage access metas
	$pcpp_subscr->manag_user_orders($user_id, $order_id, 'add');
	
	// eventually setup trial
	if(isset($_POST['pcpp_apply_trial']) && $_POST['pcpp_apply_trial']) {
		$pcpp_subscr->setup_trial_meta($user_id);
	}
}
add_action('pc_user_added', 'pcpp_add_user_assign_plan', 999);



////////////////////////////////////////////////////////////////////////////////



// IMPORT form - add fields
function pcpp_import_add_fields() {
	if(!$GLOBALS['pcpp_enabled']) {return false;}
	include_once(PCPP_DIR .'/functions.php');
	global $pcpp_subscr;
	
	?>
    <tr>
       <td class="pc_label_td"><em>Premium plans add-on</em> - <?php _e("associate plan", 'pc_ml'); ?></td>
       <td class="pc_field_td">
		<select name="pcpp_plan" autocomplete="off" class="lcweb-chosen" style="width: 100%;">
			<option value="no_plan"><?php _e("Do not associate", 'pcpp_ml') ?></option>
            <?php
            foreach($pcpp_subscr->get_plans(false) as $plan_id => $plan_name) {
                $sel = (isset($_POST['pcpp_plan']) && $_POST['pcpp_plan'] == $plan_id) ? 'selected="selected"' : '';
                echo '<option value="'.$plan_id.'" '.$sel.'>'.$plan_name . pcpp_dd_plan_details($plan_id) .'</option>'; 
            }
			?>
        </select>
       </td>
       <td><span class="info"><?php _e("Select which plan will be associated with imported users", 'pc_ml'); ?></span></td>
    </tr> 
    <?php if($pcpp_subscr->is_trial_enabled()) : ?>
    <tr>
        <td class="pc_label_td">
            <em>Premium plans add-on</em> - <?php _e('Apply trial period?', 'pcpp_ml') ?> (<?php echo $pcpp_subscr->trial_duration.' '.pcpp_sing_plur_switch($pcpp_subscr->trial_dur_type, $pcpp_subscr->trial_duration); ?>)
        </td>
        <td class="pc_field_td">
            <?php $ckd = (isset($_POST['pcpp_apply_trial']) && $_POST['pcpp_apply_trial']) ? 'checked="checked"' : ''; ?>
           <input type="checkbox" name="pcpp_apply_trial" value="1" <?php echo $ckd ?> autocomplete="off" class="ip_checks" />
        </td>
        <td></td>
    </tr>
	<?php
	endif;
}
add_action('pc_import_form', 'pcpp_import_add_fields');


// import users - perform plan association
function pcpp_import_create_orders($imported_list) {
	if(!$GLOBALS['pcpp_enabled'] || empty($imported_list) || !isset($_POST['pcpp_plan']) ||
		(isset($_POST['pcpp_plan']) && empty($_POST['pcpp_plan'])) || 
		(isset($_POST['pcpp_plan']) && $_POST['pcpp_plan'] == 'no_plan')
	) {return false;}
	
	include_once(PCPP_DIR .'/functions.php');
	global $pc_users, $pcpp_subscr;
	
	// get plan specifications
	$plan_id = (int)$_POST['pcpp_plan'];
	$plan_data = $pcpp_subscr->get_plan_data($plan_id);
	
	
	// get users data to perform actions
	$args = array(
		'user_id'	=> array_keys($imported_list),
		'to_get' 	=> array('id', 'name', 'surname', 'username', 'email', 'tel', 'wp_user_id'),
		'limit' 	=> -1
	);
	$users_data = $pc_users->get_users($args);

	// create order
	foreach($users_data as $ud) {
		$order_id = $pcpp_subscr->create_order($ud['id'], $plan_id, $ud);	
		if($order_id) {
			
			// set new main order and manage access metas
			$pcpp_subscr->manag_user_orders($ud['id'], $order_id, 'add');
			
			// eventually setup trial
			if($pcpp_subscr->is_trial_enabled() && isset($_POST['pcpp_apply_trial']) && $_POST['pcpp_apply_trial']) {
				$pcpp_subscr->setup_trial_meta($ud['id']);
			}
		}
	}
}
add_action('pc_imported_users', 'pcpp_import_create_orders');




////////////////////////////////////////////////////////////////////////////////




// PC CAT RESTRICTIONS - add plans to allow plan-based restriction
function pcpp_user_cat_dd_opts($opts) {
	if(!$GLOBALS['pcpp_enabled']) {return $opts;}
	
	include_once(PCPP_DIR .'/functions.php');
	global $pcpp_subscr;
	
	$opts['pcpp_plans'] = array(
		'name' => __('Premium Plans', 'pcpp_ml'),
		'opts' => array()
	);
	
	foreach($pcpp_subscr->get_plans(false) as $plan_id => $plan_name) {
		$opts['pcpp_plans']['opts'][ 'PCPP_'.$plan_id ] = 'PP - '.$plan_name;		
	}
	
	return $opts;
}
add_filter('pc_user_cat_dd_opts', 'pcpp_user_cat_dd_opts');



// USER CATEGORIES TAXONOMY - add field to associate plan
// add custom fields
//add_action('pg_user_categories_add_form_fields','pcpp_ucat_fields', 15, 2);
//add_action('pg_user_categories_edit_form_fields' , "pcpp_ucat_fields", 15, 2);

function pcpp_ucat_fields($tax_data) {
	global $pcpp_subscr;
  	
	$plans = $pcpp_subscr->get_plans(false);
  	$sel_plan = false;
  
	// check for existing taxonomy meta for term ID
	if(is_object($tax_data)) {
		$term_id = $tax_data->term_id;
		$sel_plan = get_option('pc_cat_'.  $term_id .'_rel_pcpp_plan');
	}

	
	// creator layout
	if(!is_object($tax_data)) :
?>
    <div class="form-field">
        <label>Premium Plans add-on - <?php _e('associated plan', 'pcpp_ml') ?></label>
        <select name="pcpp_linked_plan" autocomplete="off" style="width: 95%;">
            <option value=""><?php _e('Do not associate', 'pcpp_ml') ?></option>
            <?php 
            foreach($plans as $plan_id => $name) {
                $sel = ($sel_plan == $plan_id) ? 'selected="selected"' : '';
                echo '<option value="'.$plan_id.'" '.$sel.'>'. $name . pcpp_dd_plan_details($plan_id) .'</option>';   
            }
            ?>
        </select>
        <p style="display: inline-block; padding-left: 5px;"><?php _e("Select which plan to associate to this user category", 'pcpp_ml') ?>.<br/>
        <?php _e("Users not belonging to the plan won't have access to related restricted areas", 'pcpp_ml') ?></p>
    </div>
    
	<?php else: ?>
    
	 <tr class="form-field">
      <th scope="row" valign="top"><label>Premium Plans add-on - <?php _e('associated plan', 'pcpp_ml') ?></label></th>
      <td>
        <select name="pcpp_linked_plan" autocomplete="off" style="max-width: 550px; width: 95%;">
            <option value=""><?php _e('Do not associate', 'pcpp_ml') ?></option>
            <?php 
            foreach($plans as $plan_id => $name) {
                $sel = ($sel_plan == $plan_id) ? 'selected="selected"' : '';
                echo '<option value="'.$plan_id.'" '.$sel.'>'. $name . pcpp_dd_plan_details($plan_id) .'</option>';   
            }
            ?>
        </select>
        <p class="description"><?php _e("Select which plan to associate to this user category", 'pcpp_ml') ?>.<br/>
            <?php _e("Users not belonging to plan <strong>won't have access</strong> to related restricted areas", 'pcpp_ml') ?></p>
      </td>
    </tr>
<?php
	endif;
}


// save fields
//add_action('created_pg_user_categories', 'pcpp_save_ucat_fields', 15, 2);
//add_action('edited_pg_user_categories', 'pcpp_save_ucat_fields', 15, 2);

function pcpp_save_ucat_fields($term_id) {
    if (isset($_POST['pcpp_linked_plan']) ) {
        update_option('pc_cat_'.  $term_id .'_rel_pcpp_plan', $_POST['pcpp_linked_plan']); 
    }
}




////////////////////////////////////////////////////////////////////////////////




// eventually remove orders on user deletion
function pcpp_del_order_on_user_del($user_id) {
	if(get_option('pcpp_del_orders_on_user_del')) {
		global $pc_meta;
		$user_orders = $pc_meta->get_meta($user_id, 'pcpp_orders');
		
		if(is_array($user_orders)) {
			$GLOBALS['pcpp_deleting_user_orders'] = true;
			
			foreach($user_orders as $order_id) {
				wp_delete_post($order_id, true);	
			}
		}
	}
}
add_action('pc_pre_user_delete', 'pcpp_del_order_on_user_del');



// update user orders on order post deletion
function pcpp_update_on_order_deletion($order_id) {
	if(!$GLOBALS['pcpp_enabled'] || isset($GLOBALS['pcpp_deleting_user_orders'])) {return false;}
	global $pc_users, $pcpp_subscr;

	// search if user has got this order as main one 
	$args = array(
		'to_get' => array('id', 'pcpp_orders'),
		'search' => array(
			array('key' => 'pcpp_active_order', 'operator' => '=', 'val' => $order_id)
		)
	);
	$result = $pc_users->get_users($args);

	if(!empty($result)) {
		$pcpp_subscr->manag_user_orders($result[0]['id'], $order_id, 'remove');
	}
}
add_action('before_delete_post', 'pcpp_update_on_order_deletion');




////////////////////////////////////////////////////////////////////////////////




// USERS LIST - add badge to flag user subscription status
function pcpp_users_list_badge($badges, $user_id) {
	if(!$GLOBALS['pcpp_enabled']) {return $badges;}
	include_once(PCPP_DIR .'/functions.php');
	global $pc_meta, $pcpp_subscr;
	
	// prior status check
	$subscr_status = $pc_meta->get_meta($user_id, 'pcpp_subscr_status');
	if(empty($subscr_status)) {
		return $badges;	
	}
	
	// recheck expiration date if is marked as active
	if($subscr_status == 'active') {
		$subscr_status = $pcpp_subscr->check_user_subscr_expir($user_id);	
	}
	
	$user_plan = $pc_meta->get_meta($user_id, 'pcpp_plan');
	
	$badges .= '<img src="'.PCPP_URL.'/img/status_badges/'. $subscr_status .'.png" title="'. esc_attr( get_the_title($user_plan) .' - '. pcpp_subscr_statuses($subscr_status) .' '. __('subscription', 'pcpp_ml')) .'" />';
	return $badges;
}
add_filter('pc_users_list_badges', 'pcpp_users_list_badge', 10, 2);





////////////////////////////////////////////////////////////////////////////////




// COUNTRY FIELD TRICK - override chosen field in framework
function pcpp_country_f($fields) {
	$affected = get_option('pcpp_bill_country_f');
	
	if(empty($affected) || !isset($fields[$affected]) || !$GLOBALS['pcpp_enabled']) {
		return $fields;
	}
	$f = $fields[$affected]; 
	
	
	// opts
	if(PCPP_ECOMMERCE == 'woocomm') {
		$countries_obj   = new WC_Countries();
		$opts = $countries_obj->__get('countries');
	}
	
	
	$new_f_structure = array(
		'type' => 'assoc_select',
		'subtype' 	=> '',
		'opt'		=> $opts,
		'label'		=> $f['label'],
		'placeh'	=> (isset($f['placeh'])) ? $f['placeh'] : '',	
		'icon'		=> (isset($f['icon'])) ? $f['icon'] : '',	
		'note' 		=> $f['note'],	
	);
	$fields[$affected] = $new_f_structure;

	return $fields;	
}
add_filter('pc_form_fields_filter', 'pcpp_country_f', 999);




////////////////////////////////////////////////////////////////////////////////



//// EXPORT USERS integration

// add field
function pcpp_export_field() {
	if(!$GLOBALS['pcpp_enabled']) {return false;}
	?>
	<tr>
      <td class="pc_label_td"><?php _e("Export subscriptions data", 'pcpp_ml') ?></td>
      <td class="pc_field_td">
          <input type="checkbox" name="pcpp_export_data" value="1" class="ip_checks" autocomplete="off" />
      </td>
    </tr>
    <?php
}
add_action('pc_export_form', 'pcpp_export_field');


// add fields to the export query
function pcpp_export_fields($to_get) {
	
	if(isset($_POST['pcpp_export_data'])) {
		$to_get['pcpp_plan'] 			= __("Subscription's plan", 'pcpp_ml');
		$to_get['pcpp_subscr_end'] 		= __("Subscription's end", 'pcpp_ml');
		$to_get['pcpp_subscr_status'] 	= __("Subscription's status", 'pcpp_ml');
	
		$GLOBALS['pcpp_doing_export'] = current_time('timestamp'); 
		$GLOBALS['pcpp_export_u_expir_date'] = array();
	}
	return $to_get;
}
add_filter('pc_export_fields', 'pcpp_export_fields');


// manipulate fetched data
function pcpp_export_data_to_human($data, $index) {
	include_once(PCPP_DIR .'/functions.php');
	
	if(!isset($GLOBALS['pcpp_doing_export'])) {
		return $data;	
	}
	
	
	if($index == 'pcpp_plan') {
		return ($data) ? get_the_title($data) : '';	
	}
	
	elseif($index == 'pcpp_subscr_end') {
		$GLOBALS['pcpp_export_u_expir_time'] = $data;
		
		if($data == 'unlimited') {
			return __('no expiration', 'pcpp_ml');	
		}
		
		return (!empty($data)) ? date_i18n('Y-m-d H:i:s', (int)$data) : '';
	}
	
	elseif($index == 'pcpp_subscr_status') {
		
		// avoid checking every user and just check if expir data already passed
		if(
			isset($GLOBALS['pcpp_export_u_expir_time']) &&
			$GLOBALS['pcpp_export_u_expir_time'] && $GLOBALS['pcpp_export_u_expir_time'] != 'unlimited' &&
			$GLOBALS['pcpp_export_u_expir_time'] <= $GLOBALS['pcpp_doing_export']
		) {
			$data = 'expired';
		}
		return ($data) ? pcpp_subscr_statuses($data) : '';	
	}
	

	return $data;		
}
add_filter('pc_data_to_human', 'pcpp_export_data_to_human', 10, 2);




////////////////////////////////////////////////////////////////////////////////




// MAIL ACTIONS INTEGRATIONS 
if(is_plugin_active('private-content-mail-actions/pc_mail_actions.php') || is_plugin_active('pvtcontent_bundle/pvtcontent_bundle.php') || defined('PCMA_DIR')) :

// pcma settings - add tab	
function pcpp_pcma_tabs($tabs) {
	$tabs['pcpp_expir_reminder'] = 'Premium Plans add-on';
	return $tabs;	
}
add_filter('pcma_settings_tabs', 'pcpp_pcma_tabs');	
	

// forewarning time custom field
function pcpp_expir_reminder_forewarn_field($field_id, $field, $value, $all_vals) {
	$num = get_option('pcpp_expir_reminder_forewarn_num', 1);
	$type = get_option('pcpp_expir_reminder_forewarn_type');
	?>
	<table class="widefat lcwp_settings_table pc_settings_block">
    	<tbody>
            <?php 
			/*
			<tr class="<?php echo $field_id ?>">
                <td class="lcwp_sf_label">
                    <label><?php echo $field['label'] ?></label>
                </td>
                <td class="lcwp_sf_field">
                    <input name="pcpp_expir_reminder_forewarn_num" value="<?php echo $num ?>" maxlength="2" style="text-align: center; width: 54px; display: inline-block;" autocomplete="off" type="number" min="1" max="59" />
                   
                    <select name="pcpp_expir_reminder_forewarn_type" style="width: 120px; position: relative; top: -3px;" autocomplete="off">
                        <option value="days"><?php _e('days', 'pcpp_ml') ?></option>
                        <option value="weeks" <?php if($type == 'weeks') {echo 'selected="selected"';} ?>><?php _e('weeks', 'pcpp_ml') ?></option>
                        <option value="months" <?php if($type == 'months') {echo 'selected="selected"';} ?>><?php _e('months', 'pcpp_ml') ?></option>
                    </select>
                </td>
                <td><span class="lcwp_sf_note"><?php echo $field['note'] ?></span></td>
            </tr>
			*/ ?>
			
            <tr>
            	<td class="lcwp_sf_label">
                	<?php _e("Reminder's endpoint <small>(to be used in server's cronjob)</small>", 'pcpp_ml') ?>
                </td>
                <td colspan="2">               	
                    <a href="javascript:void(0)" onclick="pcpp_copy()" title="<?php echo esc_attr( __('copy endpoint', 'pcpp_ml')) ?>" id="pcal_copy">
                    	<strong id="pcpp_see_endpoint"><?php echo PCPP_URL ?>/expir_subscr_reminder.php</strong>
                    	&nbsp; <span class="dashicons dashicons-admin-page"></span>
                    </a>
                    
                    <script type="text/javascript">
					jQuery(document).ready(function() {
						
						// copy url attr
						window.pcpp_copy = function() {
							var $temp = jQuery("<input>");
							jQuery("body").append($temp);
							$temp.val( jQuery('#pcpp_see_endpoint').text() ).select();
						 
							document.execCommand("copy");
							$temp.remove();	
							
							alert("<?php echo esc_attr(__('Endpoint copied in your clipboard', 'pcpp_ml')) ?>");
						};
					});
					</script>
                </td>
        </tbody>
    </table>
    <?php
}	
	
	
// pcma settings - add tab contents	
function pcpp_pcma_tab_content($structure) {
	
	$def_subj 	= __("Your subscription has expired", 'pcp_ml');
	$def_txt	= __('Hello %USERNAME%, 
your subscription on %SITE-TITLE% has expired.

We wish you would like to stay with us. Click on the following link to renew now:
%RENEW-LINK%', 'pcpp_ml');
	
	
	$structure['pcpp_expir_reminder'] = array(
		'pcpp_see_forewarn' => array(
			'sect_name'	=>  __("Expired Subscription's Reminder", 'pcpp_ml'),
			'fields' 	=> array(
			
				'pcpp_expir_reminder_forewarn' => array(
					'type'		=> 'custom',
					'label'		=> __('Reminder forewarning', 'pcpp_ml'),
					'callback'	=> 'pcpp_expir_reminder_forewarn_field',
					/*'validation'=> array(
						array('index' => 'pcpp_expir_reminder_forewarn_num', 'label' => __("Subscription expiration - forewarning", 'pcpp_ml'), 'type' => 'int', 'min_val' => 1, 'required' => true),
						array('index' => 'pcpp_expir_reminder_forewarn_type', 'label' => 'Subscription expiration - forewarning type'),
					),*/
					
					'note' => __('Set when users reminder is sent', 'pcpp_ml')
				),
			),
		),
		
		'pcpp_see_texts' => array(
			'sect_name'	=>  __('E-mail builder', 'pcma_ml'),
			'fields' 	=> array(
				
				'pcpp_see_legend' => pcma_phs_legend(
					array(
						'%SITE-TITLE%'	=> __('Website title specified in WP settings', 'pcp_ml'),
						'%NAME%'		=> __("User's name", 'pcp_ml'),
						'%SURNAME%'		=> __("User's surame", 'pcp_ml'),
						'%USERNAME%'	=> __("User's userame", 'pcp_ml'),
						'%MAIL%'		=> __("User's e-mail", 'pcp_ml'),
						'%RENEW-LINK%'	=> __("User's renew page link", 'pcp_ml'),
					)
				),
				'pcpp_see_title' => array(
					'label' 	=> __('E-mail title', 'pcp_ml'),
					'type'		=> 'text',
					'def' 		=> $def_subj,
					'fullwidth' => true,
				),
				'pcud_see_txt' => array(
					'label' => __("E-mail text", 'pcp_ml'),
					'type'	=> 'wp_editor',
					'def' 	=> $def_txt,
					'rows' 	=> 13,
				), 
			),
		),
	);
	
	return $structure;
}
add_action('pcma_settings_structure', 'pcpp_pcma_tab_content');		


// mail actions integration's end	
endif;

