<?php
// EXPIRED SUBSCRIPTION'S REMINDER - PHP ENDPOINT


//////////////////////////////////////////////////////////////
// load WP functions

if(!isset($_REQUEST['abspath'])) {
	$curr_path = dirname(__FILE__);
	$curr_path_arr = explode(DIRECTORY_SEPARATOR, $curr_path);
	
	$true_path_arr = array();
	foreach($curr_path_arr as $part) {
		if($part == 'wp-content') {break;}
		$true_path_arr[] = $part;
	}	
	$true_path = implode('/', $true_path_arr);
}
else {$true_path = urldecode($_REQUEST['abspath']);}

// main functions
if(!file_exists($true_path . '/wp-load.php')) {die('<p>wordpress - wp-load.php file not found</p>');}
else {require_once($true_path . '/wp-load.php');}
	


if(!function_exists('get_filesystem_method')) {
	// wp-admin/includes/file.php - for wp_filesys
	if(!file_exists(ABSPATH . 'wp-admin/includes/file.php')) {die('<p>wordpress - file.php file not found</p>');}
	else {require_once(ABSPATH . 'wp-admin/includes/file.php');}	
}
/////////////////////////////////////////////////////////////////////////////////////




// be sure Mail Actions add-on is active
if(!defined('PCMA_DIR')) {
	die('Mail Actions add-on not found');	
}
include_once(PCMA_DIR .'/functions.php');




// include PC globals
global $pc_users, $pc_meta, $pcpp_subscr;


// get users with expired subscription
$args = array(
	'limit'		=> -1,
	'status'	=> 1,
	'to_get'	=> array('id', 'name', 'surname', 'username', 'email', 'tel', 'categories', 'psw', 'pcpp_subscr_status', 'pcpp_active_order'),
	'search'	=> array(
		array(
			'key' 		=> 'pcpp_subscr_status',
			'operator'	=> 'IN', 
			'val'		=> array('expired', 'active')
		),
		array(
			'key' 		=> 'email',
			'operator'	=> '!=', 
			'val'		=> ''
		),
	)
);
$users = $pc_users->get_users($args);

if(empty($users)) {
	die('No users to notify');	
}



// mail texts
$raw_title = get_option('pcpp_see_title');
$raw_txt = get_option('pcud_see_txt');



// is there renew link?
if(strpos($raw_txt, '%RENEW-LINK%') !== false) {
	
	$renew_pag = get_permalink(get_option('pcpp_order_renew_page'));
	if(empty($renew_pag)) {
		die('No renew page specified');	
	}	
}




// send reminders
$report = array(
	'already_notif' => array(), 
	'notif' => array()
);
foreach($users as $data) {
	$uid = $data['id'];
	
	// check expiration date if is marked as active
	if($data['pcpp_subscr_status'] == 'active') {
		$data['pcpp_subscr_status'] = $pcpp_subscr->check_user_subscr_expir($uid);	
		
		if($data['pcpp_subscr_status'] == 'active') {
			continue;	
		}
	}
	
	
	// this user has already been notified?
	if($pc_meta->get_meta($uid, 'pcpp_expier_subscr_notified')) {
		$report['already_notif'][$uid] = $data['username'];	
		continue;	
	}
	
	
	// send	
	$title = pcma_replace_placeholders($uid, $raw_title, $data);
	$txt = pcma_replace_placeholders($uid, $raw_txt, $data);
	
	if(isset($renew_pag)) {
		$link_url = add_query_arg(array(
				'pcpp_action' => 'order_ok',
				'uid' => $uid,
				'oid' => md5($data['pcpp_active_order']), 
			), 
			$renew_pag
		);		
		$txt = str_replace('%RENEW-LINK%', '<a href="'. $link_url .'">'. $link_url .'</a>', $txt);
	}
	
	$mail_sent = pcma_send_mail($data['username'], $data['email'], $title, $txt);
	
	
	$pc_meta->add_meta($uid, 'pcpp_expier_subscr_notified', current_time('mysql'));
	$report['notif'][$uid] = $data['username'];
}





// write report
echo '<p><strong>'. count($report['notif']) .' NOTIFIED USERS:</strong> '. implode(', ', $report['notif']) .'</p>';

if(count($report['already_notif'])) {
	echo '<p><strong>'. count($report['already_notif']) .' ALREADY NOTIFIED:</strong> '. implode(', ', $report['already_notif']) .'</p>';		
}







