jQuery(document).ready(function() {
	var pcpp_is_acting = false;
	
	// create renew order and redirect (no plan change)
	jQuery(document.body).delegate('a.pcpp_renew_plan_btn', 'click', function() {
		if(pcpp_is_acting) {return false;}
		pcpp_is_acting = true;
		
		var $subj = jQuery(this);
		$subj.html(pcpp_renew_is_acting);
		
		jQuery.ajax({
			type: "POST",
			url: window.location.href,
			dataType: "json",
			data: "type=pcpp_renew_order&uid=" + parseInt($subj.attr('rel')),
			success: function(response){
				if(response.status == 'success') {
					$subj.html(pcpp_renew_ok);
					window.location.href = response.url;
				} 
				else {
					$subj.html(response.error);	
				}

				pcpp_is_acting = false;
			}
		});
	});
	
	
	// create renew order and redirect (with plan change)
	jQuery(document.body).delegate('.pcpp_change_plan_btn', 'click', function() {
		if(pcpp_is_acting) {return false;}
		pcpp_is_acting = true;
		
		var $form = jQuery(this).parents('form');
		var $subj = jQuery(this);
		
		$subj.addClass('pc_loading_btn');
		$form.find('.pcpp_form_message').empty();
		
		var data = {
			type	: 'pcpp_renew_order', 
			uid 	: $form.find('input[name=pcpp_uid]').val(),
			pid		: $form.find('select').val(),
			coupon	: ($form.find('.pcpp_hidden_coupon_field').length) ? $form.find('.pcpp_hidden_coupon_field').val() : ''	
		};
		
		jQuery.ajax({
			type: "POST",
			url: window.location.href,
			dataType: "json",
			data: data,
			success: function(response){
				if(response.status == 'success') {
					$form.find('.pcpp_form_message').html('<span class="pc_success_mess">' + pcpp_renew_ok + '</span>');
					window.location.href = response.url;
				} 
				else {
					$form.find('.pcpp_form_message').html('<span class="pc_error_mess">' + response.error + '</span>');	
				}

				pcpp_is_acting = false;
			}
		});
	});
	
	
	//////////////////////////////////////////////////////////
	
	
	// manage plan switch
	jQuery(document.body).delegate('.pcpp_plan_ul > li:not(.pcpp_chosen)', 'click', function() {
		var $subj = jQuery(this).parents('form');
		var new_val = jQuery(this).attr('rel');
		
		// deactivate old one
		$subj.find('.pcpp_plan_ul li.pcpp_chosen').removeClass('pcpp_chosen');
		jQuery(this).addClass('pcpp_chosen');
		
		// set dropdown
		$subj.find('.pcpp_plan_dd option').removeAttr('selected');
		$subj.find('.pcpp_plan_dd option[value='+ new_val +']').attr('selected', 'selected');
		
		// remove expanded mode in case
		if($subj.find('.pcpp_dd_expanded').size()) {
			$subj.find('#pcpp_plan_dd_label i').trigger('click');	
		}
	});
	
	
	//  dropdown simulation for 1-col
	jQuery(document.body).delegate('#pcpp_plan_dd_label i', 'click', function() {
		var $subj = jQuery(this).parents('.pcpp_plan_choice_wrap');
		
		if($subj.hasClass('pcpp_dd_expanded')) {
			$subj.removeClass('pcpp_dd_expanded');
		}
		else {
			$subj.addClass('pcpp_dd_expanded');	
		}
	});
	
	
	//////////////////////////////////////////////////////////
	
	
	// coupon check
	var submit_coupon = function($input) {
		if(!$input.val() || pcpp_is_acting) {return false;}
		
		pcpp_is_acting = true;
		$input.parents('.pcpp_coupon_wrap').find('.pc_field_container > *').fadeTo(200, 0.7);
		
		var data = {
			type		: 'pcpp_coupon_check', 
			pcpp_coupon : $input.val()	
		};
		jQuery.ajax({
			type: "POST",
			url: window.location.href,
			dataType: "json",
			data: data,
			success: function(response){		
				if(response.status == 'success') {
					var $plans_wrap = $input.parents('form').find('.pcpp_plan_ul');
					
					jQuery.each(response.prices, function(plan_id, new_price) {
						var $price_tag = $plans_wrap.find('li[rel='+ plan_id +'] .pcpp_plan_price');
						if($price_tag.hasClass('pcpp_is_free')) {
							return true;	
						}
						
						var old_price = $price_tag.html();
						$price_tag.html('<mark class="pcpp_old_price">'+ old_price +'</mark>'+ new_price); 
					});
					
					var $clone = $input.clone();
					$clone.insertBefore($input);
					
					$clone.attr('disabled', 'disabled');
					$input.addClass('pcpp_hidden_coupon_field').attr('type', 'hidden');
					$input.next('.pcpp_try_coupon').addClass('pcpp_remove_coupon');
				} 
				else {
					$input.parents('section').prepend('<div class="pc_field_error">'+ response.mess +'</div>');		
				}
				pcpp_is_acting = false;
			}
		});
	};
	
	
	// submit coupon clicking icon
	jQuery(document).delegate('.pcpp_try_coupon:not(.pcpp_remove_coupon)', 'click', function() {
		submit_coupon(jQuery(this).parents('.pcpp_coupon_wrap').find('input'));
	});
	
	// submit coupon with enter key
	setTimeout(function() {
		jQuery('input[name="pcpp_coupon"]').unbind("keypress").keypress(function(event){
			event.cancelBubble = true;
			if(event.stopPropagation) event.stopPropagation();
			
			if(event.keyCode === 13){ // enter key
				event.preventDefault();
				submit_coupon(jQuery(this));
			}
		});
	}, 100);
	
	
	// remove coupon
	jQuery(document).delegate('.pcpp_remove_coupon', 'click', function() {
		jQuery(this).removeClass('pcpp_remove_coupon');
		jQuery('.pcpp_hidden_coupon_field').remove();
		
		// reset field
		jQuery(this).prev('.pcpp_coupon').removeAttr('disabled').val('');
		
		// reset prices
		var $plans_wrap = jQuery(this).parents('form').find('.pcpp_plan_ul');
		$plans_wrap.find('li .pcpp_plan_price').each(function() {
           if(jQuery(this).find('mark').length) {
				jQuery(this).html( jQuery(this).find('mark').html() );   
		   }
        });
	});
	
	
}); 